/*
 *  Copyright (C) 2008 Patrik Gornicz, Gornicz_P (at) hotmail (dot) com.
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "Screen.h"

#include "Entities/PhysicsEntity.h"
#include "Entities/Ball.h"


/// ***** Constructors/Destructors *****

Screen::Screen()
{

}
Screen::~Screen()
{

}

/// ***** Public Class Methods *****

Vector2 Screen::positionDelta(const PhysicsEntity* e, float /*time_step*/) const
{
    const Vector2& pos = e->positionRaw();

    Vector2 acc(0,0);

    float radius = 0;
    const Ball* b = dynamic_cast<const Ball*>(e);
    if( b != NULL )
        radius = b->getRadius();


    if(pos.m_fY > 600-radius)
        acc.m_fY += 600-radius - pos.m_fY;

    if(pos.m_fY < 0+radius)
        acc.m_fY += 0+radius - pos.m_fY;

    if(pos.m_fX > 800-radius)
        acc.m_fX += 800-radius - pos.m_fX;

    if(pos.m_fX < 0+radius)
        acc.m_fX += 0+radius - pos.m_fX;

    return acc;
}

Vector2 Screen::velocityDelta(const PhysicsEntity* e, float /*time_step*/) const
{
    const Vector2& pos = e->positionRaw();
    const Vector2& velo = e->velocityRaw();

    Vector2 acc(0,0);

    float CoR = e->CoR;
    float radius = 0;
    const Ball* b = dynamic_cast<const Ball*>(e);
    if( b != NULL )
        radius = b->getRadius();


    if(pos.m_fY > 600-radius && velo.m_fY > 0)
        acc.m_fY += velo.m_fY * -(1 + CoR);

    if(pos.m_fY < 0+radius && velo.m_fY < 0)
        acc.m_fY += velo.m_fY * -(1 + CoR);

    if(pos.m_fX > 800-radius && velo.m_fX > 0)
        acc.m_fX += velo.m_fX * -(1 + CoR);

    if(pos.m_fX < 0+radius && velo.m_fX < 0)
        acc.m_fX += velo.m_fX * -(1 + CoR);

    return acc;
}
