/*
 *  Copyright (C) 2008 Patrik Gornicz, Gornicz_P (at) hotmail (dot) com.
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef EFFECTMANAGER_H
#define EFFECTMANAGER_H

#include <bear/Vector2.h>
using namespace bear;

#include "Entities/PhysicsEntity.h"

/// ***** Header Methods *****
namespace effect
{
    void init();
    void clean();

    void update(float);
    void handleInput();

    Vector2 positionDelta(const PhysicsEntity*, float);
    Vector2 velocityDelta(const PhysicsEntity*, float);
    Vector2 forceDelta(const PhysicsEntity*, float);
}

#endif // EFFECTMANAGER_H
